<template>
  <template-page
    ref="pageRef"
    :get-list="getList"
    :exportList="exportList"
    :table-attributes="tableAttributes"
    :table-events="tableEvents"
    :options-evens-group="optionsEvensGroup"
    :moreParameters="moreParameters"
    :column-parsing="columnParsing"
  >
  </template-page>
</template>

<script>
import TemplatePage from '@/components/template/template-page-1.vue'
import { required, mobileRequired, mobile, httpUrl, email } from '@/components/template/rules_verify.js'
import { policyOrderListIn, policyOrderListInExport, policyOrderImport } from '@/api/workersCompensationInsurance'
import operation_mixin from '@/components/template/operation_mixin.js'
import import_mixin from '@/components/template/import_mixin.js'
import { commonTemplateDownload } from '@/api/common.js'
export default {
  components: { TemplatePage },
  mixins: [operation_mixin, import_mixin],
  data() {
    return {
      // 表格属性
      tableAttributes: {
        // 启用勾选列
        selectColumn: false
      },
      // 表格事件
      tableEvents: {
        'selection-change': this.selectionChange
      },
      // 勾选选中行
      recordSelected: []
    }
  },
  computed: {
    // 更多参数
    moreParameters() {
      return [
        {
          name: '保单状态',
          key: 'policyOrderStatus',
          value: '',
          conditions: [
            {
              label: '全部',
              value: ''
            },
            {
              label: '待购买',
              value: 'DGM'
            },
            {
              label: '保障中',
              value: 'BZZ'
            },
            {
              label: '待生效',
              value: 'DSX'
            },
            {
              label: '已失效',
              value: 'YSX'
            }
          ]
        }
      ]
    },
    optionsEvensGroup() {
      return [
        [
          [
            this.optionsEvensAuth('download', {
              click: () => {
                commonTemplateDownload({ name: '工伤险购买明细模板.xlsx' }, `${this.$route.meta.title}`)
                  .then(res => {
                    this.$message({
                      message: '下载成功',
                      type: 'success'
                    })
                  })
                  .catch(err => {
                    this.$message.error('下载失败')
                  })
              }
            })
          ],
          [
            this.optionsEvensAuth('import', ({ moduleName }) => {
              return {
                name: moduleName,
                render: () => {
                  return this.importButton(policyOrderImport, moduleName)
                }
              }
            })
          ]
        ]
      ]
    },
    formItems() {
      return []
    }
  },
  created() {},
  methods: {
    // 列表请求函数
    getList(p, cb) {
      var pam = JSON.parse(JSON.stringify(p))
      try {
        if (pam.policyOrderStatus) {
          pam.params.push({ param: 'policy_order_status', compare: '=', value: pam.policyOrderStatus })
        }
        cb && cb(pam)
        return policyOrderListIn(pam)
      } catch (err) {
        console.log(err)
      }
    },
    // 列表导出函数
    exportList: policyOrderListInExport,
    // 表格列解析渲染数据更改
    columnParsing(item, defaultData) {
      return defaultData
    },
    // 表格操作列
    operation(h, { row, index, column }) {}
  }
}
</script>

<style lang="scss" scoped>
.tab {
  padding: 20px 20px 0 20px;
}
</style>
